#include <windows.h>
#include "CViewBase.h"
#include "..\Util\StrUtil.h"

CViewBase::CViewBase(){
	m_hWnd = NULL;
	m_hInst = NULL;

	ZeroMemory(&m_DrawRect,sizeof(RECT));

	m_szSkinFolder[0] = '\0';
}

CViewBase::~CViewBase(){
}

//`̃EChE̐ݒ
void CViewBase::SetWindow(HWND hWnd){
	m_hWnd = hWnd;
}

void CViewBase::SetInstance(HINSTANCE hInst){
	m_hInst = hInst;
}

void CViewBase::SetDrawOffSet(RECT rc){
	CopyMemory(&m_DrawRect,&rc,sizeof(RECT));
}

void CViewBase::GetDrawOffSet(RECT *pRc){
	CopyMemory(pRc,&m_DrawRect,sizeof(RECT));
}

//////////////////////////////////////////////////////////////////////////////
//`p̊֐
//:hdc -> `foCXReLXg
//     hFont -> `ɎgptHg
//     pszText -> `悷镶
//     pFont -> `悷tHg̐F܂ލ\
//     pRect -> `͈
//߂l:TRUE -> AFALSE -> s
BOOL CViewBase::Draw_Text(HDC hdc,HFONT hFont,char *pszText,PTDIGI_SKIN_FONT *pFont,RECT *pRect){
	HGDIOBJ hObj = NULL;
	COLORREF colOld,colOldBk;
	int nOldBkMode;

	if(hFont != NULL)
		hObj = SelectObject(hdc,hFont);

	if(pFont->nTransparent == 0){
		//ߏȂꍇ
		nOldBkMode = SetBkMode(hdc,OPAQUE);
		colOldBk = SetBkColor(hdc, RGB(pFont->backColor.rgbRed,
							pFont->backColor.rgbGreen,
							pFont->backColor.rgbBlue));
	}
	else{
		//ߏsꍇ
		nOldBkMode = SetBkMode(hdc,TRANSPARENT);
	}

	colOld = SetTextColor(hdc, RGB(	pFont->textColor.rgbRed,
							pFont->textColor.rgbGreen,
							pFont->textColor.rgbBlue));

	//`悷
	DrawText(hdc,pszText,strlen(pszText),pRect,DT_NOPREFIX|DT_LEFT);

	SetTextColor(hdc,colOld);
	SetBkMode(hdc,nOldBkMode);
	if(pFont->nTransparent == 0){
		SetBkColor(hdc,colOldBk);
	}

	if(hObj != NULL)
		SelectObject(hdc,hObj);

	return TRUE;
}

BOOL CViewBase::Draw_TextW(HDC hdc,HFONT hFont,wchar_t *pszText,PTDIGI_SKIN_FONT *pFont,RECT *pRect){
	HGDIOBJ hObj = NULL;

	COLORREF colOld,colOldBk;
	int nOldBkMode;

	if(hFont != NULL)
		hObj = SelectObject(hdc,hFont);

	if(pFont->nTransparent == 0){
		//ߏȂꍇ
		nOldBkMode = SetBkMode(hdc,OPAQUE);
		colOldBk = SetBkColor(hdc, RGB(pFont->backColor.rgbRed,
							pFont->backColor.rgbGreen,
							pFont->backColor.rgbBlue));
	}
	else{
		//ߏsꍇ
		nOldBkMode = SetBkMode(hdc,TRANSPARENT);
	}

	colOld = SetTextColor(hdc, RGB(	pFont->textColor.rgbRed,
							pFont->textColor.rgbGreen,
							pFont->textColor.rgbBlue));

	//`悷
	DrawTextW(hdc,pszText,wcslen(pszText),pRect,DT_NOPREFIX|DT_LEFT|DT_WORDBREAK);

	SetTextColor(hdc,colOld);
	SetBkMode(hdc,nOldBkMode);

	if(pFont->nTransparent == 0){
		SetBkColor(hdc,colOldBk);
	}

	if(hObj != NULL)
		SelectObject(hdc,hObj);

	return TRUE;
}

BOOL CViewBase::Draw_TextW(HDC hdc,HFONT hFont,wchar_t *pszText,
						   COLORREF colText,COLORREF colBack,
						   BOOL IsTransparent,
						   RECT *pRect,
						   DWORD dwFlag){
	HGDIOBJ hObj = NULL;

	COLORREF colOld,colOldBk;
	int nOldBkMode;

	if(hFont != NULL)
		hObj = SelectObject(hdc,hFont);

	if(IsTransparent == FALSE){
		//ߏȂꍇ
		nOldBkMode = SetBkMode(hdc,OPAQUE);
		colOldBk = SetBkColor(hdc, colBack);
	}
	else{
		//ߏsꍇ
		nOldBkMode = SetBkMode(hdc,TRANSPARENT);
	}

	colOld = SetTextColor(hdc, colText);

	//`悷
	DrawTextW(hdc,pszText,wcslen(pszText),pRect,dwFlag);

	SetTextColor(hdc,colOld);
	SetBkMode(hdc,nOldBkMode);

	if(IsTransparent == FALSE){
		SetBkColor(hdc,colOldBk);
	}

	if(hObj != NULL)
		SelectObject(hdc,hObj);

	return TRUE;
}

BOOL CViewBase::Draw_TextA_Bold(HDC hdc,HFONT hFont,char *pszText,
						   COLORREF colText,COLORREF colBack,
						   BOOL IsTransparent,
						   RECT *pRect,
						   DWORD dwFlag){
	HGDIOBJ hObj = NULL;

	COLORREF colOld,colOldBk;
	int nOldBkMode;

	if(hFont != NULL)
		hObj = SelectObject(hdc,hFont);

	if(IsTransparent == FALSE){
		//ߏȂꍇ
		nOldBkMode = SetBkMode(hdc,OPAQUE);
		colOldBk = SetBkColor(hdc, colBack);
	}
	else{
		//ߏsꍇ
		nOldBkMode = SetBkMode(hdc,TRANSPARENT);
	}


	//`悷
#if 0
	BYTE bR,bG,bB;
	bR = GetRValue(colText) / 4;
	bG = GetGValue(colText) / 4;
	bB = GetBValue(colText) / 4;
	colOld = SetTextColor(hdc, RGB(bR,bG,bB));
#endif
	colOld = SetTextColor(hdc, 0);

	pRect->left -= 1;
	pRect->top -= 1;
	DrawTextA(hdc,pszText,strlen(pszText),pRect,dwFlag);
	
	pRect->top += 2;
	DrawTextA(hdc,pszText,strlen(pszText),pRect,dwFlag);

	pRect->left += 2;
	DrawTextA(hdc,pszText,strlen(pszText),pRect,dwFlag);

	pRect->top -= 2;
	DrawTextA(hdc,pszText,strlen(pszText),pRect,dwFlag);

	SetTextColor(hdc, colText);
	pRect->left -= 1;
	pRect->top += 1;
	DrawTextA(hdc,pszText,strlen(pszText),pRect,dwFlag);

	SetTextColor(hdc,colOld);
	SetBkMode(hdc,nOldBkMode);

	if(IsTransparent == FALSE){
		SetBkColor(hdc,colOldBk);
	}

	if(hObj != NULL)
		SelectObject(hdc,hObj);

	return TRUE;
}

BOOL CViewBase::Draw_TextW_Bold(HDC hdc,HFONT hFont,wchar_t *pszText,
						   COLORREF colText,COLORREF colBack,
						   BOOL IsTransparent,
						   RECT *pRect,
						   DWORD dwFlag){
	HGDIOBJ hObj = NULL;

	COLORREF colOld,colOldBk;
	int nOldBkMode;

	if(hFont != NULL)
		hObj = SelectObject(hdc,hFont);

	if(IsTransparent == FALSE){
		//ߏȂꍇ
		nOldBkMode = SetBkMode(hdc,OPAQUE);
		colOldBk = SetBkColor(hdc, colBack);
	}
	else{
		//ߏsꍇ
		nOldBkMode = SetBkMode(hdc,TRANSPARENT);
	}


	//`悷
#if 0
	BYTE bR,bG,bB;
	bR = GetRValue(colText) / 4;
	bG = GetGValue(colText) / 4;
	bB = GetBValue(colText) / 4;
	colOld = SetTextColor(hdc, RGB(bR,bG,bB));
#endif
	colOld = SetTextColor(hdc, 0);

	pRect->left -= 1;
	pRect->top -= 1;
	DrawTextW(hdc,pszText,wcslen(pszText),pRect,dwFlag);//|DT_WORDBREAK);
	
	//pRect->left += 2;
	pRect->top += 2;
	DrawTextW(hdc,pszText,wcslen(pszText),pRect,dwFlag);//|DT_WORDBREAK);

	pRect->left += 2;
	//pRect->top += 2;
	DrawTextW(hdc,pszText,wcslen(pszText),pRect,dwFlag);//|DT_WORDBREAK);

	//pRect->left = 3;
	pRect->top -= 2;
	DrawTextW(hdc,pszText,wcslen(pszText),pRect,dwFlag);//|DT_WORDBREAK);

	SetTextColor(hdc, colText);
	pRect->left -= 1;
	pRect->top += 1;
	DrawTextW(hdc,pszText,wcslen(pszText),pRect,dwFlag);//|DT_WORDBREAK);

	SetTextColor(hdc,colOld);
	SetBkMode(hdc,nOldBkMode);

	if(IsTransparent == FALSE){
		SetBkColor(hdc,colOldBk);
	}

	if(hObj != NULL)
		SelectObject(hdc,hObj);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//`Ɏg̍𓾂
BOOL CViewBase::GetFontSize(HFONT hFont,int *pnWidth,int *pnHeight){
	HGDIOBJ hObj = NULL;
//	SIZE stSize;
	TEXTMETRIC stTextMetric;
	BOOL lRet;

	if(hFont == NULL) return FALSE;

	HDC hdc = GetDC(m_hWnd);

	hObj = SelectObject(hdc,hFont);

	//if(GetTextExtentPoint32(hdc,"I",1,&stSize) == 0)
	//	stSize.cy = 0;
	ZeroMemory(&stTextMetric,sizeof(TEXTMETRIC));
	lRet = GetTextMetrics(hdc,&stTextMetric);

	if(pnWidth != NULL)*pnWidth = stTextMetric.tmMaxCharWidth;
	if(pnHeight != NULL)*pnHeight = stTextMetric.tmHeight;

	if(hObj != NULL)
		SelectObject(hdc,hObj);

	ReleaseDC(m_hWnd,hdc);
	
	if(lRet != 0)return TRUE;
	return FALSE;
}

