#pragma warning(disable : 4995)

#include <tchar.h>
#include <streams.h>

//EChEwb_
#include "CBaseWnd.h"
#include "CMsgWindow.h"
#include "CMiniCtrlWnd.h"
#include "CSplashWindow.h"

//BonCuwb_
#include "..\DtvEngine\DtvEngine.h"

//̑wb_
#include "..\Setting\CSetting.h"
#include "..\DB\CDBTvInfo.h"

//EChETCY̒`
#define VIDWND_MIN_WIDTH 160
#define VIDWND_MIN_HEIGHT 120

//^C}[ID
#define TIMERID_MOUSECUR 1
#define TIMERID_CLOCK 2

//萔̒`
#define TIME_MOUSECUR 7000

enum _enumVideoSizeMode{
	VIDEO_SIZE_MODE_100 = 0,
	VIDEO_SIZE_MODE_25,
	VIDEO_SIZE_MODE_50,
	VIDEO_SIZE_MODE_75,
	VIDEO_SIZE_MODE_125,
	VIDEO_SIZE_MODE_150,
	VIDEO_SIZE_MODE_200,
};

class CMainWindow : public CBaseWnd,
					public CDtvEngineHandler{
public:
	CMainWindow();
	~CMainWindow();

	//o֐

	//EChE̍쐬
	virtual HWND CreateWnd(DWORD dwExStyle,DWORD dwStyle,
				int x,int y,int nWidth,int nHeight,
				HWND hwndParent,
				HMENU hmenu,
				HINSTANCE hinst);

	//ݒ̕ۑ^ǂݍ
	BOOL LoadWndPos(RECT *pRc);
	BOOL SaveWndPos(void);

	//XvbVEChEݒ
	void put_SpashWindow(CSplashWindow *pWnd);

	//ʑ
	void put_Volume(long lVol);

	//EChEvVbW
	LRESULT WndProck(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	//Cxgnh
	const DWORD OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam);
	
	//ʑR[obN
	static LONG WINAPI VolumeCallback(LPVOID wP,long lVol);

private:

	//oϐ
	CDtvEngine *m_pDtvEngine;
	CSetting m_cSetting;
	CMsgWindow *m_pOsdWnd;
	CMiniCtrlWnd *m_pPlayWnd;
	CSplashWindow *m_pSplashWindow;

	BOOL m_IsPopUpMenu;

	HMODULE m_hDriver;
	HANDLE m_hThreadSnapShot;

	//DBe
	CDBTVInfo m_DbTVInfo;		//`l

	//DirectShowp֐
	void SetChannel(int nIdx);
	long Get_db_AudioVol(long lInVolume);
	BOOL CreateSnapShot(char *pszFile,int nType,int nQuality);

	//DBp֐
	BOOL DB_Init(void);			//DBJ
	BOOL DB_UnInit(void);		//DB

	//DTVGW
	BOOL DTV_Init(char *pszDriver);
	BOOL DTV_UnInit(void);

	//EChȆ
	BOOL AdjustWindow(void);
	int GetVWndWheelMode(void);
	void UpdatePlayWnd(void);
	BOOL GetVideoSize(int nMode,SIZE *pSize);

	//OSD
	BOOL DrawOSDMessage(char *pszStr);
	void AdjustOSDWnd(void);
	void DrawOSDChannel(void);
	
	//̑
	BOOL CreateDefaultSaveFolder(char *pszVideoFolder,char *pszSnapShotFolder);
	int GetDispTime(void);
	

	//^C}[nh
	void TimerProc_MouseCur(void);
	void TimerProc_Clock(void);

	//j[XVnh
	void OnUpdateTopMost(HMENU hMenu);
	void OnUpdateFullScreen(HMENU hMenu);
	void OnUpdatePlayer(HMENU hMenu);
	void OnUpdateAudioStereo(HMENU hMenu);
	void OnUpdateAudioReight(HMENU hMenu);
	void OnUpdateAudioLeft(HMENU hMenu);


	//R}hnh
	void OnExit(void);
	void OnCfg(void);
	void OnRecStart(void);
	void OnRecStop(void);
	void OnTunerCfg(void);
	void OnSetChannel(int nIdx);
	void OnSetChannelRmt(int nIdx);
	void OnFullScreen(void);
	void OnTopMost();
	void OnVolMute(void);
	void OnVolUp(void);
	void OnVolDown(void);
	void OnChUp(void);
	void OnChDown(void);
	void OnSnapShot(void);
	void OnPlayer(void);
	void OnStop(void);
	void OnAudioStereo(void);
	void OnAudioRight(void);
	void OnAudioLeft(void);
	void OnVideo25(void);
	void OnVideo50(void);
	void OnVideo75(void);
	void OnVideo100(void);
	void OnVideo125(void);

	//bZ[Wnh
	LRESULT OnWmCreate(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam);
	LRESULT OnWmClose(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam);
	LRESULT OnWmCommand(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWmDestroy(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam);
	LRESULT OnWmSize(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam);
	LRESULT OnWmInitMenu(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWmRButtonDown(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWmLButtonDown(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWMLButtonDbclk(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWmSysCommand(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWmMouseMove(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
#ifdef WM_MOUSEWHEEL
	LRESULT OnWmMouseWheel(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
#endif //WM_MOUSEWHEEL
	LRESULT OnWmTimer(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam);
	LRESULT OnWmMenuSelect(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
};